from function import load_image, join
import pygame
class Button:
    def __init__(self, rect=(0,0), height=50,  width=-1, fontsize=40, background=(123,200,50), colour=(100,100,100), oncolour=(200,0,0), hcolour=(230,230,230), text='BUTTON', padding=5, action=lambda: None):
        self.image = load_image("blankp.png", -1, True)
        self.image = self.image.convert_alpha()
        #self.image.set_colorkey(self.image.get_at((0,0)))

        font = pygame.font.Font('ethnocentric rg.ttf', fontsize)
        text_surf = font.render(text, True, colour)
        height = text_surf.get_height()
        htext_surf = font.render(text, True, hcolour)
        ontext_surf = font.render(text, True, oncolour)
        text_place = [0,0]
        if width == -1:
            width = text_surf.get_width() + 2*padding
            text_place = padding, (height-text_surf.get_height()) / 2
        else:
            text_place = (width-text_surf.get_width()) / 2, (height-text_surf.get_height()) / 2
        self.image = pygame.transform.scale(self.image, (width, height))
        self.off_image = self.image.copy()
        self.on_image = self.image.copy()
        self.h_image = self.image.copy()

        self.off_image.blit(text_surf, text_place)
        self.on_image.blit(ontext_surf, text_place)
        self.h_image.blit(htext_surf, text_place)

        self.free_image = self.off_image

        self.image = self.off_image.copy()
        
        self.rect = self.image.get_rect()
        self.rect.topleft = rect
        self.press = False
        self.function = action

    def pressed(self):
        self.press = True
        self.image = self.on_image.copy()
    def mouse_release(self, on):
        self.image = self.free_image
        if self.press:
            if on:
                self.function()
            else:
                self.press = False
    def enter(self):
        if self.press:
            self.function()
    def set_pos(self,x,y):
        self.rect.x = x
        self.rect.y = y
    def mouse_on(self):
        pass
    def mouse_off(self):
        pass
